<?php
chdir("../");
require "../config/config.php";
require "../config/attributes.php";
require GALAXYTOOL_ROOT."/secret/includes/authorization.inc.php";
session_start();
$NO_PAGE_FORWARD = true;
require GALAXYTOOL_ROOT."/secret/includes/logincheck.inc.php";
if (isset($error_page_code) && $error_page_code == "timeout") exit("");

if (!isset($_GET['type']) && !isset($_POST['type'])) exit("1");

if (isset($_GET['type'])) $type = $_GET['type'];
else $type = $_POST['type'];

if ($_SESSION['s_auth']->get_permission(iAuthorization::permission_maintenance) !== true) exit("no permission");
Galaxytool::load_language_file($_SESSION['lang']);

if ($type != "reload_all" && $type != "reload_galaxy" && $type != "reload_stats") exit("unknown type");

require GALAXYTOOL_ROOT."/secret/parser/OGameAPI.inc.php";
ob_start();
$parser = new OGameAPIParser($global_mysql_con, $global_universe, $dbtablename, $systemtablename, $playertable, $allytable);

switch ($type) {
	case "reload_all":
		$result = $parser->load_OGame_data($_SESSION['s_auth']->get_setting(iAuthorization::setting_userid));
		break;

	case "reload_galaxy":
		$result = $parser->load_OGame_universe_data($_SESSION['s_auth']->get_setting(iAuthorization::setting_userid));
		break;

	case "reload_stats":
		$result = $parser->load_OGame_statistics_data($_SESSION['s_auth']->get_setting(iAuthorization::setting_userid));
		break;

}


if ($result === true) {
	$messages = new ErrorObject(ErrorObject::severity_info, INSTALL_STEP8_LOAD_DATA_FINISHED);
} else {
	$messages = $parser->get_error_object();
}
$output = ob_get_clean();
if ($output != "") {
	$messages->add_child_message(new ErrorObject(ErrorObject::severity_error, $output));
}

echo '{ result: '.json_encode($result).', messages: '.$messages->get_JSON_result().' }';
exit();
