<?php
chdir("../");
require "../config/config.php";
require "../config/attributes.php";
require GALAXYTOOL_ROOT."/secret/includes/authorization.inc.php";
session_start();

$NO_PAGE_FORWARD = true;
require GALAXYTOOL_ROOT."/secret/includes/logincheck.inc.php";
if (isset($error_page_code) && $error_page_code == "timeout") exit("");
require GALAXYTOOL_ROOT."/secret/includes/shoutbox.inc.php";

$shoutbox = new Shoutbox($global_mysql_con, $shouttable);
if (!isset($_GET['type']) && !isset($_POST['type'])) exit("type missing");

if (isset($_GET['type'])) $type = $_GET['type'];
else $type = $_POST['type'];

switch ($type) {
	case "delete":
		header("content-type: text/html; charset=utf-8");
		header("Pragma: no-cache");
		header("Expires: 0");

		if (!isset($_POST['id']) || !is_numeric($_POST['id'])) exit();
		$id = intval($_POST['id']);
		$response = $shoutbox->delete_entry($id);

		$messages = $shoutbox->get_error_object();
		$message_json = ($messages != null) ? $messages->get_JSON_result() : "null";
		$result = '{ result: '.json_encode($response).' , messages: '.$message_json.' }';
		exit($result);
		break;

	case "insert":
		header("content-type: text/html; charset=utf-8");
		header("Pragma: no-cache");
		header("Expires: 0");

		if (!isset($_POST['comment']) || trim($_POST['comment']) == "") {
			exit("comment missing");
		}
		$comment = trim(strip_tags(stripslashes($_POST['comment'])));
		$response = $shoutbox->insert_entry($comment, $_SESSION['s_auth']->get_setting(iAuthorization::setting_username), $maxshouts);
		$messages = $shoutbox->get_error_object();
		$message_json = ($messages != null) ? $messages->get_JSON_result() : "null";
		$result = '{ result: '.json_encode($response).' , messages: '.$message_json.' }';
		exit($result);
		break;

	case "read":
		header("Content-type: application/json");
		header("Pragma: no-cache");
		header("Expires: 0");

		echo $shoutbox->read_data($_SESSION['s_auth']->get_setting(iAuthorization::setting_timezone_offset), true);

		break;

	default:
		exit("unknown type");
}
