<?php
chdir("../");
header("content-type: text/html; charset=utf-8");
require "../config/config.php";
require "../config/attributes.php";
require GALAXYTOOL_ROOT."/secret/includes/authorization.inc.php";
session_start();
$NO_PAGE_FORWARD = true;
require GALAXYTOOL_ROOT."/secret/includes/logincheck.inc.php";
if (isset($error_page_code) && $error_page_code == "timeout")
	exit("");
require GALAXYTOOL_ROOT."/secret/includes/status.inc.php";

if ($_SESSION['s_auth']->get_permission(iAuthorization::permission_statusview) !== true)
	exit("no permission");

if (!isset($_SESSION['lang']))
	$_SESSION['lang'] = $default_language;
Galaxytool::load_language_file($_SESSION['lang']);

try {
	$planets    = (isset($_GET['planets'])) ? intval($_GET['planets']) : 1;
	$status_obj = new StatusInfo($global_mysql_con, $dbtablename, $systemtablename, $utablename, $playertable, $allytable, $reporttable, $noticetable);
	$infos = $status_obj->getPlanetsInfo($planets);
} catch (Exception $e) {
	exit("Exception occurred: " . $e->getMessage());
}

echo '<table style="width:100%">';
if ($infos === false || count($infos) == 0) {
	echo "<tr><td>" . SHOW_NOTHING . "</td></tr>";
} else {
	arsort($infos);
	foreach ($infos as $player_id => $data) {
		echo "<tr><td>" . $data[0] . " - <a href=\"playerinformation.php?id=$player_id\">" . $data[1] . "</a></td>";
	}
}
echo '</table>';